# Getting Started with Minikube on Mac

## Chapter Goals

1. Setup all prerequisites for minikube (Docker and Virtualbox)
2. Setup and test Minikube
3. Setup and test kubectl

### Setup Prerequisities

#### Docker:

* Download links for Docker for Windows: https://www.docker.com/docker-windows
* Download links for Docker for Linux: https://docs.docker.com/engine/installation/linux/docker-ce/ubuntu
* Download links for Docker for Mac: https://www.docker.com/docker-mac

Command to test: `docker version`

#### Virtualbox

* Download link: https://www.virtualbox.org/

Command to test: `virtualbox`

### Setup Kubectl:
* Download link: https://kubernetes.io/docs/tasks/tools/install-kubectl/#install-kubectl-binary-via-curl

Command to test: `kubectl version`


### Setup Minikube:
* General Download Instructions: https://kubernetes.io/docs/tasks/tools/install-minikube/
* Download link: https://github.com/kubernetes/minikube/releases

Command to test: `minikube version`

# Setup Instructions:

## Docker:

* Download links for Docker for Windows: https://www.docker.com/docker-windows
* Download links for Docker for Linux: https://docs.docker.com/engine/installation/linux/docker-ce/ubuntu
* Download links for Docker for Mac: https://www.docker.com/docker-mac

Command to test: 
```
docker version
```

## Kubectl:
* Download link: https://kubernetes.io/docs/tasks/tools/install-kubectl/#install-kubectl-binary-via-curl

Command to test: 

```
kubectl version
```

## Virtualbox:
* Download link: https://www.virtualbox.org/

## Minikube:
* General Download Instructions: https://kubernetes.io/docs/tasks/tools/install-minikube/
* Download link: https://github.com/kubernetes/minikube/releases

Command to test: 
```
minikube version
```
